#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var node_tcp_proxy_1 = __importDefault(require("node-tcp-proxy"));
var awaiting_rest = false;
var partial_data = [];
var expected_len = 0;
var awaiting_rest_upstream = false;
var partial_data_upstream = [];
var expected_len_upstream = 0;
(0, child_process_1.exec)("cat /etc/resolv.conf | grep nameserver | cut -d' ' -f2", function (error, stdout, stderr) {
    if (error) {
        console.log("error: ".concat(error.message));
        return;
    }
    if (stderr) {
        console.log("stderr: ".concat(stderr));
        return;
    }
    var wsl_host_ip = stdout.replace(/^\s+|\s+$/g, '');
    console.log("Connecting to ", wsl_host_ip);
    var p = node_tcp_proxy_1.default.createProxy(6008, wsl_host_ip, 6008, {
        upstream: function (context, data) {
            if (awaiting_rest_upstream) {
                partial_data_upstream.push(data);
                var bytes_1 = 0;
                partial_data_upstream.forEach(function (buf) { return bytes_1 += buf.byteLength; });
                if (bytes_1 < expected_len_upstream) {
                    return Buffer.from('', "utf-8");
                }
                awaiting_rest_upstream = false;
                data = Buffer.concat(partial_data_upstream);
            }
            var str = data.toString('utf-8');
            var lines = str.split('\r\n');
            var headers = [];
            var body = [];
            var done_with_headers = false;
            lines.forEach(function (line) {
                if (!line) {
                    done_with_headers = true;
                    return;
                }
                if (done_with_headers)
                    body.push(line);
                else
                    headers.push(line);
            });
            var body_len = body.join("").length;
            if (!awaiting_rest_upstream) {
                for (var i = 0; i < headers.length; ++i) {
                    var _a = headers[i].split(": "), name = _a[0], value = _a[1];
                    if (name !== "Content-Length")
                        continue;
                    expected_len_upstream = Number.parseInt(value);
                }
                if (expected_len_upstream > body_len) {
                    awaiting_rest_upstream = true;
                    partial_data_upstream = [data];
                    return Buffer.from('', "utf-8");
                }
            }
            var new_body = body.join("").replace(/\\\/mnt\\\/c\\\//g, "C:\\/");
            for (var i = 0; i < headers.length; ++i) {
                var name = headers[i].split(": ")[0];
                if (name !== "Content-Length")
                    continue;
                headers[i] = "Content-Length: " + new_body.length.toString();
            }
            headers.push('');
            headers.push(new_body);
            var new_data = headers.join('\r\n');
            return Buffer.from(new_data, "utf-8");
        },
        downstream: function (context, data) {
            if (awaiting_rest) {
                partial_data.push(data);
                var bytes_2 = 0;
                partial_data.forEach(function (buf) { return bytes_2 += buf.byteLength; });
                if (bytes_2 < expected_len) {
                    return Buffer.from('', "utf-8");
                }
                awaiting_rest = false;
                data = Buffer.concat(partial_data);
            }
            var str = data.toString('utf-8');
            var lines = str.split('\r\n');
            var headers = [];
            var body = [];
            var done_with_headers = false;
            lines.forEach(function (line) {
                if (!line) {
                    done_with_headers = true;
                    return;
                }
                if (done_with_headers)
                    body.push(line);
                else
                    headers.push(line);
            });
            var body_len = body.join("").length;
            if (!awaiting_rest) {
                for (var i = 0; i < headers.length; ++i) {
                    var _a = headers[i].split(": "), name = _a[0], value = _a[1];
                    if (name !== "Content-Length")
                        continue;
                    expected_len = Number.parseInt(value);
                }
                if (expected_len > body_len) {
                    awaiting_rest = true;
                    partial_data = [data];
                    return Buffer.from('', "utf-8");
                }
            }
            var new_body = body.join("").replace(/C:\//g, "/mnt/c/");
            for (var i = 0; i < headers.length; ++i) {
                var name = headers[i].split(": ")[0];
                if (name !== "Content-Length")
                    continue;
                headers[i] = "Content-Length: " + new_body.length.toString();
            }
            headers.push('');
            headers.push(new_body);
            var new_data = headers.join('\r\n');
            return Buffer.from(new_data, "utf-8");
        },
    });
});
